/***************************************************************************
 * Some part of this script based on 
 * Generic Drag Script-  Dynamic Drive (www.dynamicdrive.com)
 * For full source code and terms of usage,
 * visit http://www.dynamicdrive.com
 ***************************************************************************/
 
/***************************************************************************
 *                        chess.js (JavaScript Chess UI)
 *                      ---------------------------------
 *   begin                : Saturday, April 8, 2006
 *   copyright            : (C) 2006 M. Yahya, boo.ifreepages.com 
 *   email                : mr.boo@telkom,net
 *
 *   $Id: chess.js,v 0.0.1 2006/4/16 20:00:00 M. Yahya Exp $
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

var ie=document.all;
var ns6=document.getElementById&&!document.all;

var dragapproved=false;
var z,x,y;
var piece_from="";
var piece_to="";
var old_x,old_y;
var played="";
var chess_id;
var op_captured="";
var old_img="";
var square_offset=square_size+square_padding;

function notation(){
  col=Math.round(parseInt(z.style.left+0)/square_offset);
  row=Math.round(parseInt(z.style.top+0)/square_offset);

  if(z.id.length>2){
    p=z.id.charAt(0);
    new_col=(z.id.charCodeAt(1)-97)+col;
    new_row=parseInt(z.id.charAt(2))-row;
  }
  else{
    p="";
    new_col=(z.id.charCodeAt(0)-97)+col;
    new_row=parseInt(z.id.charAt(1))-row;
  }

  if(piece_from==""){
    piece_from=p+String.fromCharCode(new_col+97)+new_row;
    pf="-"+String.fromCharCode(new_col+97)+new_row;
  }

  if(new_row<9 && new_row>0 && new_col<8 && new_col>=0){
    piece_to="-"+String.fromCharCode(new_col+97)+new_row;
  }
  else piece_to="";

  n=piece_from+(piece_to==pf? "" : piece_to);

  if(ie){ document.all.notation.value=n; }
  else{ document.getElementById("notation").value=n; }
}

function move(e){
  if(dragapproved){
    z.style.left=ns6? old_x+e.clientX-x : old_x+event.clientX-x;
    z.style.top=ns6? old_y+e.clientY-y : old_y+event.clientY-y;
    notation();
    return false;
  }
}

function drags(e){
  if(!ie&&!ns6)
    return;
  var firedobj=ns6? e.target : event.srcElement;
  var topelement=ns6? "HTML" : "BODY";

  while(firedobj.tagName!=topelement&&firedobj.className!="drag"){
    firedobj=ns6? firedobj.parentNode : firedobj.parentElement;
  }

  if(firedobj.className=="drag"){
    dragapproved=true;
    z=firedobj;
    z.style.zIndex=100;
    re=/z\-index\:1/;
    z.innerHTML=z.innerHTML.replace(re,"z-index:100");
    old_x=parseInt(z.style.left+0);
    old_y=parseInt(z.style.top+0);
    x=ns6? e.clientX: event.clientX;
    y=ns6? e.clientY: event.clientY;
    piece_from="";
    notation();
    document.onmousemove=move;
    return false;
  }
}

function set_promote(n,img_src,ext){
  document.getElementById("chess_pawn_promote").innerHTML=chess_form;

  switch(n){
    case 2:promote="(R)";promote_img="r";break;
    case 3:promote="(B)";promote_img="b";break;
    case 4:promote="(N)";promote_img="n";break;
    default:promote="(Q)";promote_img="q";break;
  }
  document.getElementById(list_id).innerHTML+=promote;
  played+=promote;
  
  old_img=chess_id.innerHTML;
  chess_id.innerHTML="<img "+img_src+promote_img+ext+"' border='0' style='z-index:1;'>";
  
  if(ie){ document.all.notation.value=played; }
  else{ document.getElementById("notation").value=played; }
    
  document.onmousedown=drags;
  document.onmouseup=drop;
}

function check_promote(){
  if(played.length==5&&played!="0-0-0"){
    if(played.charAt(4)=='1'||played.charAt(4)=='8'){
      RegExp("src.*(gif|png|jpg|jpeg|bmp)","i").test(chess_id.innerHTML);
      img_src=RegExp.lastMatch;
      img_src=img_src.replace(/"/,"'");
      img_src=img_src.replace(/\.(gif|png|jpg|jpeg|bmp)/i,"");
      ext=RegExp.lastMatch;
      document.onmousedown='';
      document.onmouseup='';
      document.getElementById("chess_pawn_promote").innerHTML=
      "<table class='board'><tr><td colspan='4' class='notation'>Pawn Promotion</td></tr><tr>"+
      "<td class='bdark'><img "+img_src+"q"+ext+"' border='0' title=' Queen ' onclick='set_promote(1,img_src,ext)' style='cursor:hand'></td>"+
      "<td class='blight'><img "+img_src+"r"+ext+"' border='0' title=' Rock ' onclick='set_promote(2,img_src,ext)' style='cursor:hand'></td>"+
      "<td class='bdark'><img "+img_src+"b"+ext+"' border='0' title=' Bishop ' onclick='set_promote(3,img_src,ext)' style='cursor:hand'></td>"+
      "<td class='blight'><img "+img_src+"n"+ext+"' border='0' title=' Knight ' onclick='set_promote(4,img_src,ext)' style='cursor:hand'></td>"+
      "</tr></table>";
    }
  }
}

function check_move(){
  list_p=Array("B","K","N","Q","R");
  possible=false;

  if(played==""){
    i=0;
    s=piece_from+piece_to;
    p="";
    if(s.length>5){
      p=s.charAt(0);
      s=s.substr(1,5);
    }
    s=s.substr(0,2)+s.substr(3,2);
    a=Array(s.charAt(0),s.charAt(1),s.charAt(2),s.charAt(3));
    a[2]=(a[0]==a[2]?"":a[2]);
    a[3]=(a[1]==a[3]?"":a[3]);
    b=a[0]+a[1]+a[2]+a[3];

    while(i<possible_move.length&&!possible){
      if(b==possible_move[i]){
        possible=true;chess_id=z;
        op_captured=piece_to.substr(1,2);
        j=0;
        while(!document.getElementById(op_captured)&&j<5){ op_captured=list_p[j]+piece_to.substr(1,2);j++ }
        if(document.getElementById(op_captured)){
          op_captured=document.getElementById(op_captured);
          op_captured.style.visibility='hidden';
          piece_to="x"+piece_to.substr(1,2);
        }
        else if(p==""&&Math.abs(b.charCodeAt(0)-b.charCodeAt(2))==1){
            op_captured=document.getElementById(a[2]+a[1]);
            op_captured.style.visibility='hidden';
            piece_to="x"+piece_to.substr(1,2);
        }
        else{
          op_captured="";
          piece_to="-"+piece_to.substr(1,2);
        }
        played=piece_from+piece_to;
      }
      i++;
    }

    if(p=="K"&&(b=="e8c"||b=="e1c")&&possible) played="0-0-0";
    if(p=="K"&&(b=="e8g"||b=="e1g")&&possible) played="0-0";
    document.getElementById(list_id).innerHTML+=played;
  }
  else{
    alert("   "+alert_01+played+"\n\n   "+alert_02+"     ");
  }

  if(ie){ document.all.notation.value=played; }
  else{ document.getElementById("notation").value=played; }

  return possible;
}

function chess_reset(){
  if(played!=""){
    chess_id.style.left=0;
    chess_id.style.top=0;
    if(played=="0-0"){
      if(piece_to.charAt(2)=="8") Rh8.style.left=0*square_offset;
      else Rh1.style.left=0*square_offset;
    }
    if(played=="0-0-0"){
      if(piece_to.charAt(2)=="8") Ra8.style.left=0*square_offset;
      else Ra1.style.left=0*square_offset;
    }
    ihtml=document.getElementById(list_id).innerHTML;
    document.getElementById(list_id).innerHTML=ihtml.substr(0,ihtml.length-played.length);
    played="";
    if(op_captured!=""){
      op_captured.style.visibility='visible';
      op_captured="";
    }
    if(old_img!=""){
      chess_id.innerHTML=old_img;
      old_img="";
    }
  }
}

function drop(e){
  if(dragapproved){
    if(piece_to.charAt(0)=="-"){
      if(check_move()){
        z.style.left=Math.round(parseInt(z.style.left+0)/square_offset)*square_offset;
        z.style.top=Math.round(parseInt(z.style.top+0)/square_offset)*square_offset;

        if(played=="0-0"){
          if(piece_to.charAt(2)=="8") Rh8.style.left=-2*square_offset;
          else Rh1.style.left=-2*square_offset;
        }
        if(played=="0-0-0"){
          if(piece_to.charAt(2)=="8") Ra8.style.left=3*square_offset;
          else Ra1.style.left=3*square_offset;
        }
        
        check_promote();
      }
      else{
        z.style.left=old_x;
        z.style.top=old_y;
      }
    }
    else{
      z.style.left=old_x;
      z.style.top=old_y;
    }
    z.style.zIndex=1;
    re=/z\-index\:100/;
    z.innerHTML=z.innerHTML.replace(re,"z-index:1");
    dragapproved=false;
  }
}

function type_notation(){

  typed="";list_p=Array("B","K","N","Q","R","");

  if(ie){ typed=document.all.notation.value; }
  else{ typed=document.getElementById("notation").value; }

  if(typed==""&&played!="") chess_reset();
  else{
    p="";
    correct_typed="";
    c="";
    if(RegExp("^[knqr]","i").test(typed)||RegExp("^b[a-h]","i").test(typed)){
      p=typed.substr(0,1).toUpperCase();
      typed=typed.substr(1);
    }

    typed=typed.toLowerCase();
    while(typed.length>0){
      typed0=typed.charAt(0);
      typed=typed.substr(1);

      if(RegExp("^[a-h]").test(typed0)&&(correct_typed.length==0||correct_typed.length==3)&&c==""){ correct_typed+=typed0;typed0=""; }
      if(RegExp("^[a-h]").test(typed0)&&correct_typed.length==2&&c==""){ correct_typed+="-"+typed0;typed0=""; }
      if(RegExp("^[1-8]").test(typed0)&&(correct_typed.length==1||correct_typed.length==4)&&c=="") correct_typed+=typed0;

      if(RegExp("^[o0]").test(typed0)&&correct_typed.length==0){ correct_typed+="0";c="0";typed0=""; }
      if(RegExp("^[o0]").test(typed0)&&correct_typed.length==1&&c=="0"){ correct_typed+="-0";typed0=""; }
      if(RegExp("^[o0]").test(typed0)&&correct_typed.length==3&&c=="0"){ correct_typed+="-0";typed0="";if(played!="") chess_reset(); }

      if(RegExp("^[x\-]").test(typed0)&&correct_typed.length==2&&c=="") correct_typed+=typed0;
      if(RegExp("^[x\-]").test(typed0)&&correct_typed.length==1&&c=="0"){ correct_typed+="-";if(played!="") chess_reset(); }
      if(RegExp("^[x\-]").test(typed0)&&correct_typed.length==3&&c=="0"){ correct_typed+="-";if(played!="") chess_reset(); }

      if(RegExp("^[o0]").test(typed0)&&(correct_typed.length==2||correct_typed.length==4)&&c=="0") correct_typed+="0";
    }

    typed=correct_typed;

    if(typed=="0-0"||typed=="0-0-0"||
       (typed.length==5&&RegExp("^[a-h]").test(typed))||
       (typed.length==6&&RegExp("^[BKNQR]").test(typed)))
    {
      if(typed=="0-0"||typed=="0-0-0"){
        if(list_id=="chess_white_list"){ p="";piece_from="Ke1";c="1"; }
        if(list_id=="chess_black_list"){ p="";piece_from="Ke8";c="8"; }
        if(typed=="0-0") piece_to="-g"+c;
        if(typed=="0-0-0") piece_to="-c"+c;
      }
      else{
        piece_from=p+typed.substr(0,2);
        piece_to=typed.substr(2);

        i=0;
        while(!document.getElementById(piece_from)&&i<6){ p=list_p[i];piece_from=p+typed.substr(0,2);i++ }
      }

      if(check_move()){
        row=-(parseInt(piece_to.charAt(2))-parseInt(piece_from.charAt(piece_from.length-1)));
        col=(piece_to.charCodeAt(1)-97)-(piece_from.charCodeAt(piece_from.length-2)-97);

        document.getElementById(piece_from).style.left=col*square_offset;
        document.getElementById(piece_from).style.top=row*square_offset;

        chess_id=document.getElementById(piece_from);
        typed=played.length>5?played.substr(1):played;

        if(played=="0-0"){
          p="";
          if(piece_to.charAt(2)=="8") Rh8.style.left=-2*square_offset;
          else Rh1.style.left=-2*square_offset;
        }
        if(played=="0-0-0"){
          p="";
          if(piece_to.charAt(2)=="8") Ra8.style.left=3*square_offset;
          else Ra1.style.left=3*square_offset;
        }

        check_promote();
      }
    }
    else{ if(played!="") chess_reset(); }

    if(played==""){
      if(typed=="0-0"||typed=="0-0-0") p="";
      if(ie){ document.all.notation.value=p+typed; }
      else if(ns6){ document.getElementById("notation").value=p+typed; }
    }
  }
}

function chess_onsubmit()
{
  flag=false;

  if(ie){ send_notation=document.all.notation.value; }
  else if(ns6){ send_notation=document.getElementById("notation").value; }
  
  if(send_notation==""||played==""){ alert("No piece moved"); }
  else flag=true;

  return flag;
}

document.onmousedown=drags;
document.onmouseup=drop;